/**************************************************************************/
/*                                                                        */
/*  Thibaut Balabonski, Sylvain Conchon, Jean-Christophe Filliâtre,       */
/*  Kim Nguyen, Laurent Sartre                                            */
/*                                                                        */
/*  Informatique - MP2I/MPI - CPGE 1re et 2e années.                      */
/*  Cours et exercices corrigés. Éditions Ellipses, 2022.                 */
/*                                                                        */
/*  https://www.informatique-mpi.fr/                                      */
/*                                                                        */
/**************************************************************************/

// Table de hachage
// réalisant un dictionnaire des chaînes (char*) vers les entiers (int)

#include "prelude.h"

#ifndef HASHTBL
#define HASHTBL

typedef struct Hashtbl hashtbl;

hashtbl *hashtbl_create(int capacity);

int hashtbl_size(hashtbl *h);

void hashtbl_put(hashtbl *h, char *k, int v);
  // écrase l'entrée précédente pour k, le cas échéant

bool hashtbl_contains(hashtbl *h, char *k);

int hashtbl_get(hashtbl *h, char *k);
  // renvoie -1 si la clé n'est pas dans la table

void hashtbl_remove(hashtbl *h, char *k);

void hashtbl_print(hashtbl *h);

void hashtbl_stat(hashtbl *h);

void hashtbl_delete(hashtbl *h);

#endif
